#include "lcm.h"
#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int MAX_N = 1e5 + 10;
bool prime[MAX_N];

void init() {
    prime[0] = prime[1] = true;
    for(int i = 1; i < MAX_N; i ++) {
        if(prime[i]) { continue; }
        for(int j = i * 2; j < MAX_N; j += i) {
            prime[j] = true;
        }
    }
}

std::vector<int> guessPermutation(int n) {
    if(!prime[0]) {
        init();
    }

    vector<int> cool = {}, bad = {};
    for(int i = 1; i <= n; i ++) {
        if(prime[i]) { continue; }
        ll curr = i;
        if(curr * 2 > n) {
            cool.push_back(curr);
        } else {
            while(curr * (ll)i < n) {
                curr *= i;
            }
            if(curr * 2 > n) {
                bad.push_back(curr);
            }
        }
    }

    int best_ind = 0;
    ll ped = -1;
    int last = -1;

    vector<int> indexes = {};
    vector<int> ret = {};
    for(int i = 1; i <= n; i ++) {
        indexes.push_back(i);
        ret.push_back(-1);
    }

    random_shuffle(indexes.begin(), indexes.end());

    for(int i = 0; i < indexes.size(); i ++) {
        int ind0 = indexes[(i - 1 + indexes.size()) % indexes.size()];
        int ind1 = indexes[i];
        int ind2 = indexes[(i + 1) % indexes.size()];
        ll lcm1 = lcm(ind1, ind2);

        if(ped != -1) {
            if(lcm1 % ped == 0) {
                best_ind = ind1;
                ret[ind2 - 1] = lcm1 / ped;
            } else {
                best_ind = ind0;
                ret[ind0 - 1] = last / ped;
            }
            break;
        } else if(last != -1) {
            if(lcm1 % last == 0) {
                ret[ind1 - 1] = last;
            } else {
                ret[ind0 - 1] = last;
            }
        }

        for(const auto it : cool) {
            if(lcm1 % it == 0) {
                ped = it;
                last = lcm1;
                continue;
            }
        }

        last = -1;
        for(const auto it : bad) {
            if(lcm1 % it == 0) {
                last = it;
                break;
            }
        }
    }

    for(int i = 1; i <= n; i ++) {
        if(ret[i - 1] != -1) { continue; }
        if(i == best_ind) {
            ret[i - 1] = ped;
        } else {
            ret[i - 1] = lcm(i, best_ind) / ped;
        }
    }

    return ret;
}

/*
4
1
2 3 1 4
*/
