#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
using namespace std;
#define endl "\n"
typedef long long ll;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const ll mod = 2e9 + 7;

const ll MAX_N = 1 << 17;
ll arr[MAX_N];
ll n, q;

ll solve(ll l, ll r, ll p) {
    const auto eval = [&](ll x) {
        ll sum = 0;
        ll mn = mod;
        for(ll i = l; i <= r; i ++) {
            sum += max(arr[i], x);
            chkmin(mn, max(arr[i], x));
        }
        return mn * (ll)(r - l + 1) * 1000ll >= p * sum;
    };

    ll lft = 0, rght = mod;
    while(lft < rght - 1) {
        ll mid = (lft + rght) / 2ll;
        if(eval(mid)) {
            rght = mid;
        } else {
            lft = mid;
        }
    }

    ll ret = 0;
    for(ll i = l; i <= r; i ++) {
        ret += max(arr[i], rght) - arr[i];
    }
    return ret;
}

struct query {
    ll l, r, p, ind;
};

struct ller {
    ll l, r, ind;
};

bool operator <(const ller &a, const ller &b) {
    return a.l + a.r < b.l + b.r;
}

query quer[MAX_N];
pair<ll, ll> num[MAX_N];

struct seg_tree {
    ll tree[2 * MAX_N];

    ll sum(ll curr, ll l, ll r, ll ql, ll qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(ql > r || qr < l) {
            return 0;
        }
        ll m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }

    void upd(ll curr, ll l, ll r, ll ind, ll val) {
        if(l == r && l == ind) {
            tree[curr] = val;
            return;
        } else if(l > ind || r < ind) {
            return;
        }
        ll m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    void build_empty() {
        fill_n(tree, 2 * MAX_N, 0);
    }

    void build(ll curr, ll l, ll r) {
        if(l == r) {
            tree[curr] = arr[l];
            return;
        }
        ll m = (l + r) / 2ll;
        build(curr * 2, l, m);
        build(curr * 2 + 1, m + 1, r);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }
};

seg_tree small, big, aux;

void reset() {
    small.build_empty();
    big.build(1, 0, n - 1);
}

ll ans[MAX_N];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(ll i = 0; i < n; i ++)  {
        cin >> arr[i];
        num[i] = {arr[i], i};
    }
    sort(num, num + n);

    vector<ller> curr, nxt;

    for(ll i = 0; i < q; i ++) {
        ll l, r, p;
        cin >> l >> r >> p;
        quer[i] = {l - 1, r - 1, p, i};
        curr.push_back({0, mod, i});
    }

    while(true) {
        reset();

        ll ptr = 0;
        for(const auto it : curr) {
            if(it.l == it.r - 1) {
                ans[it.ind] = it.r;
                continue;
            }
            ll m = (it.l + it.r) / 2ll;
            while(ptr < n && m >= num[ptr].first) {
                small.upd(1, 0, n - 1, num[ptr].second, 1);
                big.upd(1, 0, n - 1, num[ptr].second, 0);
                ptr ++;
            }
            ll sum = big.sum(1, 0, n - 1, quer[it.ind].l, quer[it.ind].r) + m * small.sum(1, 0, n - 1, quer[it.ind].l, quer[it.ind].r);
            if(m * (ll)(quer[it.ind].r - quer[it.ind].l + 1) * 1000ll >= quer[it.ind].p * sum) {
                nxt.push_back({it.l, m, it.ind});
            } else {
                nxt.push_back({m, it.r, it.ind});
            }
        }

        if(nxt.empty()) {
            break;
        }

        sort(nxt.begin(), nxt.end());
        curr = nxt;
        nxt.resize(0);
    }

    vector<pair<int, int> > ped = {};
    for(int i = 0; i < q; i ++) {
        ped.push_back({ans[i], i});
    }
    sort(ped.begin(), ped.end());

    aux.build_empty();
    small.build_empty();
    int ptr = 0;
    for(int i = 0; i < q; i ++) {
        while(ptr < n && ped[i].first >= num[ptr].first) {
            aux.upd(1, 0, n - 1, num[ptr].second, num[ptr].first);
            small.upd(1, 0, n - 1, num[ptr].second, 1);
            ptr ++;
        }
        int ind = ped[i].second;
        ans[ind] = small.sum(1, 0, n - 1, quer[ind].l, quer[ind].r) * ans[ind] - aux.sum(1, 0, n - 1, quer[ind].l, quer[ind].r);
    }

    for(ll i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

