#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse4")
using namespace std;
#define endl "\n"
typedef long long ll;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const ll mod = 1e9 + 7;

const ll MAX_N = 1e5 + 10;
const ll MAX_Q = 5e5 + 10;
int arr[MAX_N];
ll n, q;

struct query {
    int l, r, p, ind;
};

struct ller {
    int l, r, ind;
};

bool operator <(const ller &a, const ller &b) {
    return a.l + a.r < b.l + b.r;
}

query quer[MAX_Q];
pair<int, int> num[MAX_N];

template<class T>
struct fenwick {
    T tree[MAX_N];

    void upd(ll ind, ll val) {
        ind ++;
        for(; ind < MAX_N; ind += (ind & (-ind))) {
            tree[ind] += val;
        }
    }

    ll sum(ll ind) {
        ind ++;
        ll ret = 0;
        for(; ind != 0; ind -= (ind & (-ind))) {
            ret += tree[ind];
        }
        return ret;
    }

    ll sum(ll l, ll r) {
        if(l == 0) {
            return sum(r);
        } else {
            return sum(r) - sum(l - 1);
        }
    }

    void build_empty() {
        fill(tree, tree + MAX_N, 0);
    }

    void build() {
        for(ll i = 0; i < n; i ++) {
            tree[i + 1] = arr[i];
        }
        for(ll ind = 0; ind < MAX_N; ind ++) {
            ll nxt = ind + (ind & (-ind));
            if(nxt < MAX_N) {
                tree[nxt] += tree[ind];
            }
        }
    }
};

fenwick<int> small;
fenwick<ll> big;

void reset() {
    small.build_empty();
    big.build();
}

ll ans[MAX_Q];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(ll i = 0; i < n; i ++)  {
        cin >> arr[i];
        num[i] = {arr[i], i};
    }
    sort(num, num + n);

    vector<ller> curr, nxt;

    for(ll i = 0; i < q; i ++) {
        ll l, r, p;
        cin >> l >> r >> p;
        quer[i] = {l - 1, r - 1, p, i};
        curr.push_back({0, mod, i});
    }

    while(true) {
        reset();

        ll ptr = 0;
        for(const auto it : curr) {
            if(it.l == it.r - 1) {
                ans[it.ind] = it.r;
                continue;
            }
            ll m = (it.l + it.r) / 2ll;
            while(ptr < n && m >= num[ptr].first) {
                small.upd(num[ptr].second, 1);
                big.upd(num[ptr].second, -num[ptr].first);
                ptr ++;
            }
            ll sum = big.sum(quer[it.ind].l, quer[it.ind].r) + m * small.sum(quer[it.ind].l, quer[it.ind].r);
            if(m * (ll)(quer[it.ind].r - quer[it.ind].l + 1) * 1000ll >= quer[it.ind].p * sum) {
                nxt.push_back({it.l, m, it.ind});
            } else {
                nxt.push_back({m, it.r, it.ind});
            }
        }

        if(nxt.empty()) {
            break;
        }

        sort(nxt.begin(), nxt.end());
        curr = nxt;
        nxt.resize(0);
    }

    vector<pair<ll, ll> > ped = {};
    for(ll i = 0; i < q; i ++) {
        ped.push_back({ans[i], i});
    }
    sort(ped.begin(), ped.end());

    big.build_empty();
    small.build_empty();
    ll ptr = 0;
    for(ll i = 0; i < q; i ++) {
        while(ptr < n && ped[i].first >= num[ptr].first) {
            big.upd(num[ptr].second, num[ptr].first);
            small.upd(num[ptr].second, 1);
            ptr ++;
        }
        ll ind = ped[i].second;
        ans[ind] = small.sum(quer[ind].l, quer[ind].r) * ans[ind] - big.sum(quer[ind].l, quer[ind].r);
    }

    for(ll i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}
