#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse4")
using namespace std;
#define endl "\n"
typedef long long ll;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const ll mod = 1e9 + 7;

const ll MAX_N = 1e5 + 10;
const ll MAX_Q = 5e5 + 10;
int arr[MAX_N];
ll n, q;

struct query {
    int l, r, p, ind;
};

struct ller {
    int l, r, ind;
};

bool operator <(const ller &a, const ller &b) {
    return a.l + a.r < b.l + b.r;
}

query quer[MAX_Q];
pair<int, int> num[MAX_N];

typedef pair<ll, int> node;

node operator +(const node &a, const node &b) {
    return {a.first + b.first, a.second + b.second};
}

void operator +=(node &a, const node &b) {
    a.first += b.first;
    a.second += b.second;
}

node operator -(const node &a, const node &b) {
    return {a.first - b.first, a.second - b.second};
}

struct fenwick_op {
    node tree[MAX_N];

    void upd(ll ind, const node &val) {
        ind ++;
        for(; ind < MAX_N; ind += (ind & (-ind))) {
            tree[ind] += val;
        }
    }

    node sum(ll ind) {
        ind ++;
        node ret = {0, 0};
        for(; ind != 0; ind -= (ind & (-ind))) {
            ret += tree[ind];
        }
        return ret;
    }

    node sum(ll l, ll r) {
        if(l == 0) {
            return sum(r);
        } else {
            return sum(r) - sum(l - 1);
        }
    }

    void build_empty() {
        for(int i = 0; i < MAX_N; i ++) {
            tree[i] = {0, 0};
        }
    }

    void build() {
        for(ll i = 0; i < n; i ++) {
            tree[i + 1] = {arr[i], 0};
        }
        for(ll ind = 0; ind < MAX_N; ind ++) {
            ll nxt = ind + (ind & (-ind));
            if(nxt < MAX_N) {
                tree[nxt] += tree[ind];
            }
        }
    }
};

fenwick_op op;

void reset() {
    op.build();
}

ll ans[MAX_Q];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(ll i = 0; i < n; i ++)  {
        cin >> arr[i];
        num[i] = {arr[i], i};
    }
    sort(num, num + n);

    vector<ller> curr, nxt;

    for(ll i = 0; i < q; i ++) {
        ll l, r, p;
        cin >> l >> r >> p;
        quer[i] = {l - 1, r - 1, p, i};
        curr.push_back({0, mod, i});
    }

    while(true) {
        op.build();

        ll ptr = 0;
        for(const auto it : curr) {
            if(it.l == it.r - 1) {
                ans[it.ind] = it.r;
                continue;
            }
            ll m = (it.l + it.r) / 2ll;
            while(ptr < n && m >= num[ptr].first) {
                op.upd(num[ptr].second, {-num[ptr].first, 1});
                ptr ++;
            }
            const auto ff = op.sum(quer[it.ind].l, quer[it.ind].r);
            ll sum = ff.first + m * ff.second;
            if(m * (ll)(quer[it.ind].r - quer[it.ind].l + 1) * 1000ll >= quer[it.ind].p * sum) {
                nxt.push_back({it.l, m, it.ind});
            } else {
                nxt.push_back({m, it.r, it.ind});
            }
        }

        if(nxt.empty()) {
            break;
        }

        sort(nxt.begin(), nxt.end());
        curr = nxt;
        nxt.resize(0);
    }

    vector<pair<ll, ll> > ped = {};
    for(ll i = 0; i < q; i ++) {
        ped.push_back({ans[i], i});
    }
    sort(ped.begin(), ped.end());

    op.build_empty();
    ll ptr = 0;
    for(ll i = 0; i < q; i ++) {
        while(ptr < n && ped[i].first >= num[ptr].first) {
            op.upd(num[ptr].second, {num[ptr].first, 1});
            ptr ++;
        }
        ll ind = ped[i].second;
        const auto ff = op.sum(quer[ind].l, quer[ind].r);
        ans[ind] = ff.second * ans[ind] - ff.first;
    }

    for(ll i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}
