#include <iostream>
#include <array>
#include <tuple>

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

constexpr int get_ind(int rob, int i) {
    return 3 + (rob - 1) * 3 + i;
}

constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    unsigned int n = memory[1];
    unsigned int m = memory[2];

    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
    };

    if(u == 1) {
        if(memory[get_ind(1, 1)] == 0) {
            ret[0] = MemoryOperation(SET_VAL, get_ind(1, 0), 1);
            ret[1] = MemoryOperation(ADD_VAL, get_ind(1, 1), 1);
        } else if(memory[get_ind(1, 1)] == n) {
            ret[0] = MemoryOperation(SET_VAL, 0, ANSWER_CONNECTED);
            return ret;
        } else if(memory[get_ind(1, 1)] == memory[get_ind(1, 2)]) {
            ret[0] = MemoryOperation(SET_VAL, 0, ANSWER_NOT_CONNECTED);
            return ret;
        } else {
            ret[2] = MemoryOperation(SET_VAL, get_ind(1, 2), memory[get_ind(1, 1)]);
        }
    }

    if(memory[get_ind(u, 0)] == 0) {
        return ret;
    }

    for(unsigned int i = 0; i < number_neighbours; ++i) {
        unsigned int v = neighbours[i];
        if(memory[get_ind(v, 0)] == 0) {
            ret[0] = MemoryOperation(SET_VAL, get_ind(v, 0), 1);
            ret[1] = MemoryOperation(ADD_VAL, get_ind(1, 1), 1);
            break;
        }
    }

    return ret;
}

