#include <iostream>
#include <array>
#include <tuple>

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

constexpr int get_ind(int rob, int i) {
    return 3 + (rob - 1) * 5 + i;
}

constexpr int find(int x, unsigned int *memory) {
    while(x + 1 != memory[get_ind(x, 0)]) {
        x = memory[get_ind(x, 0)];
    }
    return x;
}

constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    unsigned int n = memory[1];
    unsigned int m = memory[2];

    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(SET_VAL, 1, n),
        MemoryOperation(SET_VAL, 1, n),
        MemoryOperation(SET_VAL, 1, n),
        MemoryOperation(SET_VAL, 1, n),
        MemoryOperation(SET_VAL, 1, n),
    };

    if(memory[get_ind(u, 0)] == 0) {
        ret[0] = MemoryOperation(SET_VAL, get_ind(u, 0), u + 1);
        return ret;
    } else if(memory[get_ind(u, 0)] == u + 1 && memory[get_ind(u, 1)] != 0) {
        ret[0] = MemoryOperation(SET_VAL, get_ind(u, 0), memory[get_ind(u, 1)]);
        ret[1] = MemoryOperation(SET_VAL, get_ind(u, 1), 0);
        ret[2] = MemoryOperation(SET_VAL, get_ind(1, 2), 420);
        return ret;
    }

    if(u == 1 && memory[get_ind(u, 0)] != 0) {
        if(memory[get_ind(1, 2)] == 69) {
            int all = find(1, memory);
            for(int i = 2; i <= n; i ++) {
                if(find(i, memory) != all) {
                    ret[0] = MemoryOperation(SET_VAL, 0, ANSWER_NOT_CONNECTED);
                    return ret;
                }
            }
            ret[0] = MemoryOperation(SET_VAL, 0, ANSWER_CONNECTED);
            return ret;
        }
        ret[2] = MemoryOperation(SET_VAL, get_ind(1, 2), 69);
    }

    const auto par = find(u, memory);
    for(unsigned int i = 0; i < number_neighbours; ++i) {
        unsigned int v = neighbours[i];
        const auto new_par = find(v, memory);
        if(new_par < par) {
            ret[0] = MemoryOperation(SET_VAL, get_ind(par, 1), new_par);
            ret[1] = MemoryOperation(SET_VAL, get_ind(1, 2), 420);
        }
    }

    return ret;
}

