/**
    Happy birthday
    Рагадагадактак
    Рагадагадактак
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 10000 + 10;
const int INF  = 1e9;

struct Query
{
    int l, r, p, idx;
};

int n, q;
int a[MAXN];
int in[MAXN];
int perm[MAXN];
llong output[MAXN];
Query query[MAXN];

std::queue <int> tree[4*MAXN];

struct BIT
{
    llong tree[MAXN];
    void update(const int &pos, int val)
    {
        for (int idx = pos ; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }
    }

    llong query(const int &pos)
    {
        llong res = 0;
        for (int idx = pos ; idx > 0 ; idx -= idx & (-idx))
        {
            res += tree[idx];
        }

        return res;
    }

    void set()
    {
        std::fill(tree + 1, tree + 1 + n, 0);
        for (int i = 1 ; i <= n ; ++i)
        {
            update(i, a[i]);
        }
    }

    void reset()
    {
        std::fill(tree + 1, tree + 1 + n, 0);
    }

    llong getSum(int l, int r)
    {
        return query(r) - query(l - 1);
    }
};

BIT fenwickSum;
BIT fenwickOnes;
bool check(int l, int r, int p, int val)
{
    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += std::max(val, a[i]);
    }

    return sum * p <= 1000LL * val * (r - l + 1);
}

llong query1(int l, int r, int p)
{
    int ll = -1, rr = INF, mid;
    while (ll < rr - 1)
    {
        mid = (ll + rr) / 2;
        if (!check(l, r, p, mid)) ll = mid;
        else rr = mid;
    }

    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += std::max(0, rr - a[i]);
    }

    return rr;
}

struct Node
{
    int node, l, r;
};

llong prefix[MAXN];
std::queue <Node> waitList;
void solve()
{
    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](const int &x, const int &y)
    {
        return a[x] < a[y];
    });

    for (int i = 1 ; i <= n ; ++i)
    {
        prefix[i] = prefix[i - 1] + a[i];
    }

    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> query[i].l >> query[i].r >> query[i].p;
        tree[1].push(i);
    }

    int idx;
    int mid;
    int val;
    llong p1, q1;
    Query front;
    waitList.push({1, 1, n}); a[n + 1] = INF;
    while (!waitList.empty())
    {
        Node top = waitList.front();
        waitList.pop();

        if (top.l == 1)
        {
            fenwickSum.set();
            fenwickOnes.reset();
        }

        mid = (top.l + top.r) / 2;
        for (int i = top.l ; i <= mid ; ++i)
        {
            fenwickSum.update(perm[i], -a[perm[i]]);
            fenwickOnes.update(perm[i], 1);
        }

        if (top.l == top.r)
        {
            // за интерполиране
            while (!tree[top.node].empty())
            {
                idx = tree[top.node].front();
                front = query[idx];
                val = a[perm[mid]];

                if (front.l == front.r)
                {
                    tree[top.node].pop();
                    continue;
                }

                assert(mid < n);
                if (front.p != 1000 || front.r - front.l + 1 != fenwickOnes.getSum(front.l, front.r))
                {
                    assert(check(front.l, front.r, front.p, a[perm[mid + 1]]));
                    // assert(!check(front.l, front.r, front.p, a[perm[mid]]));
                    p1 = front.p * fenwickSum.getSum(front.l, front.r);
                    q1 = (1000LL * (front.r - front.l + 1) - fenwickOnes.getSum(front.l, front.r) * front.p);
                    val = std::max((llong)val, p1 / q1 + ((p1 % q1) > 0));
                }

                output[idx] = fenwickSum.getSum(front.l, front.r) + 1LL * val * fenwickOnes.getSum(front.l, front.r) - (prefix[front.r] - prefix[front.l - 1]);
                tree[top.node].pop();
            }
        } else
        {
            while (!tree[top.node].empty())
            {
                idx = tree[top.node].front();
                front = query[idx];
                tree[top.node].pop();

                if ((1LL * a[perm[mid + 1]] * fenwickOnes.getSum(front.l, front.r) + fenwickSum.getSum(front.l, front.r)) * front.p <= 1000LL * a[perm[mid + 1]] * (front.r - front.l + 1))
                {
                    assert(check(front.l, front.r, front.p, a[perm[mid + 1]]));
                    tree[2*top.node].push(idx);
                } else
                {
                    assert(!check(front.l, front.r, front.p, a[perm[mid + 1]]));
                    tree[2*top.node + 1].push(idx);
                }
            }

            waitList.push({2*top.node, top.l, mid});
            waitList.push({2*top.node + 1, mid + 1, top.r});
        }

        for (int i = mid + 1 ; i <= top.r ; ++i)
        {
            fenwickSum.update(perm[i], -a[perm[i]]);
            fenwickOnes.update(perm[i], 1);
        }
    }
}

void print()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << output[i] << '\n';
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    print();

    return 0;
}

// -WI,-stack 268435456
/**
11 1
8 651 4 21734 138 3 13123 2481 88328235 13818381 21411
1 11 0

11655

11 5
8 651 4 21734 138 3 13123 2481 88328235 13818381 21411
1 11 876
1 11 818
1 11 144
1 11 478
1 11 500
val is: 1515779
val is: 7289652
val is: 7857432
val is: 34542650
val is: 25621453
331548566
242336596
13582458
65547315
70657335

11 5
8 651 4 21734 138 3 13123 2481 88328235 13818381 21411
1 11 876
1 11 818
1 11 144
1 11 478
1 11 500
331548566
242336596
13582458
65547315
70657335
*/
