/**
    Happy birthday
    Рагадагадактак
    Рагадагадактак
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 10000 + 10;
const int INF  = 1e9;

struct Query
{
    int l, r, p, idx;
};

int n, q;
int a[MAXN];
int in[MAXN];
int perm[MAXN];
llong output[MAXN];
Query query[MAXN];

struct BIT
{
    llong tree[MAXN];
    void update(const int &pos, int val)
    {
        if (pos == 0) return;
        for (int idx = pos ; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }
    }

    llong query(const int &pos)
    {
        llong res = 0;
        for (int idx = pos ; idx > 0 ; idx -= idx & (-idx))
        {
            res += tree[idx];
        }

        return res;
    }

    void set()
    {
        std::fill(tree + 1, tree + 1 + n, 0);
        for (int i = 1 ; i <= n ; ++i)
        {
            update(i, a[i]);
        }
    }

    void reset()
    {
        std::fill(tree + 1, tree + 1 + n, 0);
    }

    llong getSum(int l, int r)
    {
        return query(r) - query(l - 1);
    }
};

BIT fenwickSum;
BIT fenwickOnes;
bool check(int l, int r, int p, int val)
{
    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += std::max(val, a[i]);
    }

    return sum * p <= 1000LL * val * (r - l + 1);
}

llong query1(int l, int r, int p)
{
    int ll = -1, rr = INF, mid;
    while (ll < rr - 1)
    {
        mid = (ll + rr) / 2;
        if (!check(l, r, p, mid)) ll = mid;
        else rr = mid;
    }

    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += std::max(0, rr - a[i]);
    }

    return rr;
}

int nodeL[MAXN];
int nodeR[MAXN];
struct Node
{
    int node, idx;
};

llong prefix[MAXN];
std::queue <Node> waitList, temp;
void solve()
{
    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](const int &x, const int &y)
    {
        return a[x] < a[y];
    });

    for (int i = 1 ; i <= n ; ++i)
    {
        prefix[i] = prefix[i - 1] + a[i];
    }

    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> query[i].l >> query[i].r >> query[i].p;
        waitList.push({1, i});
    }

    nodeL[1] = 1;
    nodeR[1] = n;
    int idx;
    int mid;
    int val;
    int last = -1;
    int lastL = -1;
    int l, r;

    llong p1, q1;
    Query front;
    while (!waitList.empty() || !temp.empty())
    {
        if (waitList.empty())
        {
            while (!temp.empty())
            {
                waitList.push(temp.front());
                temp.pop();
            }
        }

        Node top = waitList.front();
        waitList.pop();

        l = nodeL[top.node];
        r = nodeR[top.node];
        if (l == 1)
        {
            last = 0;
            fenwickSum.set();
            fenwickOnes.reset();
        }

        mid = (l + r) / 2;
        if (lastL != l)
        {
            while (!temp.empty())
            {
                waitList.push(temp.front());
                temp.pop();
            }

            lastL = l;
        }

        while (last + 1 <= mid)
        {
            last++;
            fenwickSum.update(perm[last], -a[perm[last]]);
            fenwickOnes.update(perm[last], 1);
        }

        if (l == r)
        {
            idx = top.idx;
            front = query[idx];
            val = a[perm[mid + 1]];

            if (front.l == front.r)
            {
                continue;
            }

            assert(mid < n);
            if (front.p != 1000 || front.r - front.l + 1 != fenwickOnes.getSum(front.l, front.r))
            {
                assert(check(front.l, front.r, front.p, a[perm[mid + 1]]));
                if (mid != 0) assert(!check(front.l, front.r, front.p, a[perm[mid]]));
                /*p1 = front.p * fenwickSum.getSum(front.l, front.r);
                q1 = (1000LL * (front.r - front.l + 1) - fenwickOnes.getSum(front.l, front.r) * front.p);
                val = std::max((llong)val, p1 / q1 + ((p1 % q1) > 0));*/

                int valL = a[perm[mid]] - 1, valR = a[perm[mid + 1]], valMid;
                while (valL < valR - 1)
                {
                    valMid = (valL + valR) / 2;
                    if (((1LL * valMid * fenwickOnes.getSum(front.l, front.r) + fenwickSum.getSum(front.l, front.r)) * front.p <= 1000LL * valMid * (front.r - front.l + 1)))
                    {
                        valR = valMid;
                    } else
                    {
                        valL = valMid;
                    }
                }

                val = valR;
            }

            output[idx] = fenwickSum.getSum(front.l, front.r) + 1LL * val * fenwickOnes.getSum(front.l, front.r) - (prefix[front.r] - prefix[front.l - 1]);
        } else
        {
            idx = top.idx;
            front = query[idx];
            if ((1LL * a[perm[mid + 1]] * fenwickOnes.getSum(front.l, front.r) + fenwickSum.getSum(front.l, front.r)) * front.p <= 1000LL * a[perm[mid + 1]] * (front.r - front.l + 1))
            {
                assert(check(front.l, front.r, front.p, a[perm[mid + 1]]));
                waitList.push({2 * top.node, top.idx});
            } else
            {
                assert(!check(front.l, front.r, front.p, a[perm[mid + 1]]));
                temp.push({2 * top.node + 1, top.idx});
            }

            nodeL[2*top.node] = nodeL[top.node];
            nodeL[2*top.node + 1] = mid + 1;
            nodeR[2*top.node] = mid;
            nodeR[2*top.node + 1] = nodeR[top.node];
        }
    }
}

void print()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << output[i] << '\n';
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    print();

    return 0;
}

// -WI,-stack 268435456
/**
8 1
89 13 73 37 44 10 1 2
1 10 500

11 1
8 651 4 21734 138 3 13123 2481 88328235 13818381 21411
1 11 0

11655

11 1
8 651 4 21734 138 3 13123 2481 88328235 13818381 21411
1 11 144
1 11 876
1 11 818
1 11 478
1 11 500
val is: 1515779
val is: 7289652
val is: 7857432
val is: 34542650
val is: 25621453
331548566
242336596
13582458
65547315
70657335

11 5
8 651 4 21734 138 3 13123 2481 88328235 13818381 21411
1 11 876
1 11 818
1 11 144
1 11 478
1 11 500
331548566
242336596
13582458
65547315
70657335
*/
