#include <iostream>
#include <array>
#include <tuple>

// (!) Не трябва да променяте дефинициите на MemoryOperation и work. В противен случай ще получите 0 точки (compilation error).

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

// За да върнете резултат от work, трябва да върнете масив "std::array<MemoryOperation, 5>" с точно 5 елемента.
// Всеки елемент на масива е от тип "MemoryOperation", като всеки елемент може да се инициализира по следния начин:
// MemoryOperation(SET_VAL, 0, 1) -> създава "SET_VAL" операция на клетка 0 със стойност 1 (memory[0] = 1)
// MemoryOperation(ADD_VAL, 0, 1) -> създава "ADD_VAL" операция на клетка 0 със стойност 1 (memory[0] += 1)

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

// За да използвате помощни функции, те също трябва да са constexpr.
constexpr int helper() {
    return 42;
}


// Функцията е constexpr, което не ви позволява да използвате глобална памет. Можете да използвате само параметрите на функцията.
constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    unsigned int n = memory[1];
    unsigned int m = memory[2];

    // Васички масиви които използваме трябва да се инициализират. Това е примерна инициализация на масива който ще върнем:

    bool good = true;
    for (int i = 1 ; i < n ; ++i)
    {
        if (memory[2 + i] != memory[3 + i])
        {
            good = false;
            break;
        }
    }

    if (good)
    {
        std::array <MemoryOperation, 5> ret =
        {
            MemoryOperation(SET_VAL, 0, 1u),
            MemoryOperation(SET_VAL, 0, 1u),
            MemoryOperation(SET_VAL, 0, 1u),
            MemoryOperation(SET_VAL, 0, 1u),
            MemoryOperation(SET_VAL, 0, 1u),
        };

        return ret;
    }

    std::vector <int> v;
    std::array <MemoryOperation, 5> ret = ret =
    {
        MemoryOperation(SET_VAL, 0, 1u),
        MemoryOperation(SET_VAL, 0, 1u),
        MemoryOperation(SET_VAL, 0, 1u),
        MemoryOperation(SET_VAL, 0, 1u),
        MemoryOperation(SET_VAL, 0, 1u),
    };;

    int cnt = 0;

    for (int i = 0 ; i < number_neighbours ; ++i)
    {
        if (i == 0 || memory[2 + neighbours[i - 1]] == memory[2 + neighbours[i]])
        {
            continue;
        } else
        {
            if (neighbours[i - 1] > neighbours[i])
            {
                ret[cnt++] = {SET_VAL, 2 + i, memory[neighbours[i - 1] + 2]};
                if (cnt == 5) break;
                memory[i + 2] = memory[2 + neighbours[i - 1]];
            } else
            {
                for (int j = i - 1 ; j >= 0 && cnt < 5 ; --j)
                {
                    if (memory[neighbours[j] + 2] != memory[2 + i]) ret[cnt++] = {SET_VAL, neighbours[j] + 2, memory[i + 2]};
                    memory[neighbours[j] + 2] = memory[2 + i];
                }
            }
        }
    }

    if (cnt == 0)
    {
        memory[2 + n + u] = 1;
        if (u == n)
        {
            bool isBad =true;
            for (int i = 1 ; i <= n ; ++i)
            {
                if (memory[2 + n + i] != 1)
                {
                    isBad = false;
                }
            }

            if (isBad)
            {
                ret =
                {
                    MemoryOperation(SET_VAL, 0, 2u),
                    MemoryOperation(SET_VAL, 0, 2u),
                    MemoryOperation(SET_VAL, 0, 2u),
                    MemoryOperation(SET_VAL, 0, 2u),
                    MemoryOperation(SET_VAL, 0, 2u),
                };

                return ret;
            }
        }
    } else
    {
        memory[2 + n + u] = 0;
        while (cnt < 5)
        {
            ret[cnt] = ret[cnt - 1];
            cnt++;
        }

        return ret;
    }
}
