#include <iostream>
#include <array>
#include <tuple>
///using namespace std;


#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

constexpr std::array<MemoryOperation, 5> work(unsigned int u, unsigned int *memory, unsigned int memory_size, unsigned int *neighbours, unsigned int number_neighbours)
{
    unsigned int n = memory[1], t=1;
    unsigned int m = memory[2];
    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(ADD_VAL, 2*n+1, 0),
        MemoryOperation(ADD_VAL, 2*n+1, 0),
        MemoryOperation(ADD_VAL, 2*n+1, 0),
        MemoryOperation(ADD_VAL, 2*n+1, 0),
        MemoryOperation(ADD_VAL, 2*n+1, 0),
    };


    if(u==1 && (memory[5*n+2]>n-1 || (memory[5*n+2] && !memory[5*n+1])))
    {
        for(int i=4*n+1; i<5*n; i++)
        {
            if(memory[i]!=memory[4*n]) t=2;
        }
        ret[0]=MemoryOperation(SET_VAL, 0, t);
    }
    else if(u==1) ret[0]=MemoryOperation(ADD_VAL, 5*n+2, 1);
    int mx=std::max(u, memory[4*n-1+u]);
    for(int i=0; i<number_neighbours; i++)
    {
       if(mx<std::max(neighbours[i], memory[4*n-1+neighbours[i]]))
            mx=std::max(neighbours[i], memory[4*n-1+neighbours[i]]);
    }
    if(mx>memory[4*n-1+u]) ret[1]=MemoryOperation(SET_VAL, 5*n+1, 1);
    ret[2]=MemoryOperation(SET_VAL, 4*n-1+u, mx);
    return ret;
}
