#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = 5e5 + 10;

ll block;
ll n, q;
ll a[maxn];

struct query
{
    ll l, r, idx;
    double c;
}ask[maxn];

bool cmp(const query &q1, const query & q2)
{
    if (q1.l / block == q2.l / block)
        return q1.r < q2.r;
    return q1.l / block < q2.l / block;
}

vector < pair < ll, ll > > val;
ll pos[maxn];
pair < ll, ll > fen[maxn];

void update_fen(ll st, ll x)
{

    for (ll i = st; i <= n; i += (i & -i))
    {

        fen[i].first += x;
        if (x > 0)
            fen[i].second ++;
        else
            fen[i].second --;
    }
}

pair < ll, ll > query(ll st)
{
    ll s = 0, t = 0;
    for (ll i = st; i > 0; i -= (i & -i))
    {
        s += fen[i].first;
        t += fen[i].second;
    }
    return {s, t};
}

ll get_pos(ll x)
{
    ll lf = 1, rf = n;
    while(lf <= rf)
    {
        ll mf = (lf + rf) / 2;
        if (val[mf].first > x)
            rf = mf - 1;
            else
                lf = mf + 1;
    }
    return rf;
}
ll solve_query(ll l, ll r, double c)
{

    ll lf = 0, rf = 1e9;
    double cs = c / (double)(r - l + 1);
    while(lf <= rf)
    {

        ll mf = (lf + rf) / 2;
        ll gt = get_pos(mf);

        pair < ll, ll > imp = query(gt);
        ll sum = query(n).first - imp.first + imp.second *  mf;

        ///cout << imp.first << " " << imp.second << " " << sum << " " << mf << endl;

        ///cout << lf << " " << rf << " " << (double)(mf) / (double)(sum) << endl;
        if ((double)(mf) / (double)(sum) >= cs)
            rf = mf - 1;
        else
            lf = mf + 1;
    }

    pair < ll, ll > imp = query(lf);
    ll step = imp.second * lf - imp.first;
    return step;
}

ll lf = 1, rf = 0;
void update(ll l, ll r)
{
    while(rf < r)
    {
        rf ++;
        update_fen(pos[rf], a[rf]);
    }

    while(lf > l)
    {
        lf --;
        update_fen(pos[lf], a[lf]);
    }

    while(rf > r)
    {
        update_fen(pos[rf], -a[rf]);
        rf --;
    }

    while(lf < l)
    {
        update_fen(pos[lf], -a[lf]);
        lf ++;
    }
}

ll ans[maxn];
void solve()
{
    cin >> n >> q;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i];
    block = sqrt(n);
    for (ll i = 1; i <= n; i ++)
    val.push_back({a[i], i});

    sort(val.begin(), val.end());
    for (ll i = 0; i < n; i ++)
        pos[val[i].second] = i + 1;

    for (ll i = 1; i <= q; i ++)
    {
        ll l, r, p;
        cin >> l >> r >> p;
        double c = p / 1000.0;
        ask[i].l = l;
        ask[i].r = r;
        ask[i].c = c;
        ask[i].idx = i;
    }


    sort(ask + 1, ask + q + 1, cmp);
    for (ll i = 1; i <= q; i ++)
    {
        update(ask[i].l, ask[i].r);

        ans[ask[i].idx] = solve_query(ask[i].l, ask[i].r, ask[i].c);
    }

    for (ll i = 1; i <= q; i ++)
        cout << ans[i] <<endl;
}

int main()
{
    solve();
    return 0;
}
/**
3 1
3 2 1
3 3 1000

*/


/**
5 1
8 3 4 5 2
1 5 900

10 1
2 8 5 1 10 5 9 9 3 5
9 10 317
*/
