#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = 1e5 + 10;

ll block;
ll n, q;
ll a[maxn];

struct query
{
    ll l, r, idx;
    ll c;
} ask[maxn];

bool cmp(const query &q1, const query & q2)
{
    if (q1.l / block == q2.l / block)
        return q1.r < q2.r;
    return q1.l / block < q2.l / block;
}

vector < pair < ll, ll > > val;
ll pos[maxn];
pair < ll, ll > fen[maxn];

void update_fen(ll st, ll x, ll tp)
{

    for (ll i = st; i <= n; i += (i & -i))
    {

        fen[i].first += x;
        fen[i].second += tp;
    }
}

pair < ll, ll > query(ll st)
{
    ll s = 0, t = 0;
    for (ll i = st; i > 0; i -= (i & -i))
    {
        s += fen[i].first;
        t += fen[i].second;
    }
    return {s, t};
}

ll get_pos(ll x)
{
    ll lf = 0, rf = n - 1;
    while(lf <= rf)
    {
        ll mf = (lf + rf) / 2;
        ///cout << lf << " : " << rf << endl;
        if (val[mf].first >= x)
            rf = mf - 1;
        else
            lf = mf + 1;
    }
    return lf ;
}
ll solve_query(ll l, ll r, double c)
{

    ll lf = 0, rf = 1e9 + 10;

    while(lf <= rf)
    {

        ll mf = (lf + rf) / 2;
        ll gt = get_pos(mf);

        pair < ll, ll > imp = query(gt);
        ll sum = query(n).first - imp.first + imp.second *  mf;
        ///cout << mf << " " << gt << " " << sum << " " << query(n).first << " " << imp.first << " " << imp.second << endl;
        //cout << imp.first << " " << imp.second << " " << sum << " " << mf << " " << c << endl;
        //cout << "size " << (r - l + 1) << endl;
        ///cout << lf << " " << rf << " " << (double)(mf) / (double)(sum) << " " << cs << endl;
        //cout << (ll)(mf * (r - l + 1)) * (ll)(1000) << " " << (ll)(c * sum) << " " << c << endl;
        if ((double)(mf * (r - l + 1)) * (double)(1000) >= (double)(c * sum))
            rf = mf - 1;
        else
            lf = mf + 1;
    }

    ll gt = get_pos(lf);

    pair < ll, ll > imp = query(gt);
    ll step = max((ll)(0), imp.second * lf - imp.first);
    return step;
}

ll lf = 1, rf = 0;
void update(ll l, ll r)
{
    while(rf < r)
    {
        rf ++;
        update_fen(pos[rf], a[rf], 1);
    }

    while(lf > l)
    {
        lf --;
        update_fen(pos[lf], a[lf], 1);
    }

    while(rf > r)
    {
        update_fen(pos[rf], -a[rf], -1);
        rf --;
    }

    while(lf < l)
    {
        update_fen(pos[lf], -a[lf], -1);
        lf ++;
    }
}

ll ans[maxn];
void solve()
{
    cin >> n >> q;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i];
    block = max(1, (int)sqrt(n));
    for (ll i = 1; i <= n; i ++)
        val.push_back({a[i], i});

    sort(val.begin(), val.end());

    for (ll i = 0; i < n; i ++)
        pos[val[i].second] = i + 1;

    for (ll i = 1; i <= q; i ++)
    {
        ll l, r, p;
        cin >> l >> r >> p;

        ask[i].l = l;
        ask[i].r = r;
        ask[i].c = p;
        ask[i].idx = i;
    }


    sort(ask + 1, ask + q + 1, cmp);
    for (ll i = 1; i <= q; i ++)
    {
        update(ask[i].l, ask[i].r);

        ans[ask[i].idx] = solve_query(ask[i].l, ask[i].r, ask[i].c);
    }

    for (ll i = 1; i <= q; i ++)
        cout << ans[i] <<endl;
}

int main()
{
    freopen("test.txt", "r", stdin);
    solve();
    return 0;
}
/**
3 1
3 2 1
3 3 1000

*/


/**
5 1
8 3 4 5 2
1 5 900

100 1
42 468 335 501 170 725 479 359 963 465 706 146 282 828 962 492 996 943 828 437 392 605 903 154 293 383 422 717 719 896 448 727 772 539 870 913 668 300 36 895 704 812 323 334 674 665 142 712 254 869 548 645 663 758 38 860 724 742 530 779 317 36 191 843 289 107 41 943 265 649 447 806 891 730 371 351 7 102 394 549 630 624 85 955 757 841 967 377 932 309 945 440 627 324 538 539 119 83 930 542
71 74 764
*/
