#include "lcm.h"

#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include "lcm1.cpp"

static const int N = 1e5 + 3;

static int n, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readInput(){
    std::vector<int> inp(n,0);

    for(int i=0;i<n;i++)
        inp[i]=i+1;

    random_shuffle(inp.begin(),inp.end());
    for(int i=0;i<n;i++)cout<<inp[i]<<" ";
    cout<<endl;
    return inp;
}

long long lcm(int i,int j)
{
    number_of_queries++;

    if(1>i || i>n || 1>j || j>n || i==j)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        cout<<i<<" "<<j<<endl;
        exit(0);
    }

    return 1LL*input[i]/std::__gcd(input[i],input[j])*input[j];
}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> inp = readInput();
    for(int i=0;i<n;i++){
        input[i+1]=inp[i];
    }

    std::vector<int> guess = guessPermutation(n);
    if(guess != inp){
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct permutation and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> n_tests;

    long long max_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        max_queries = std::max(max_queries, runOneTest());

    std::cout << "Your program successfully returned the correct permutations and used " << max_queries << " queries at worst." << std::endl;
}
