#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=5e5+5;
const int MAXQ=5e5+5;
const int block=750; //

struct query
{
    int l,r,p,num;
};

struct node
{
    long long sum;
    int d,lazy;
};

int n,q;
int a[MAXN];
int b[MAXN];
unordered_map<int,int> mp;
int decode[MAXN];
int n1;
query qr[MAXQ];
node tree[4*MAXN];
long long S=0;
long long ans[MAXQ];

bool cmp(query x, query y)
{
    int blx=x.l/block;
    int bly=y.l/block;
    if(blx==bly)
    {
        if(blx&1) return x.r>y.r;
        return x.r<y.r;
    }
    return blx<bly;
}

void compress()
{
    int num=1;
    for(int i=1;i<=n;i++) b[i]=a[i];
    sort(b+1,b+n+1);
    for(int i=1;i<=n;i++)
    {
        if(!mp[b[i]])
        {
            mp[b[i]]=num;
            decode[num++]=b[i];
        }
    }
    decode[0]=decode[1];
    n1=num-1;
}

void build(int node,int l, int r)
{
    if(l==r)
    {
        tree[node].d=decode[l]-decode[l-1];
        return;
    }
    int mid=(l+r)>>1;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node].d=tree[2*node].d+tree[2*node+1].d;
}

void push(int node,int l,int r)
{
    if(l<r)
    {
        tree[2*node].sum+=(long long) tree[2*node].d*tree[node].lazy;
        tree[2*node+1].sum+=(long long) tree[2*node+1].d*tree[node].lazy;
        tree[2*node].lazy+=tree[node].lazy;
        tree[2*node+1].lazy+=tree[node].lazy;
    }
    tree[node].lazy=0;
}

void update(int node,int l,int r,int ql,int qr,int val)
{
    if(ql<=l && r<=qr)
    {
        tree[node].sum+=(long long)tree[node].d*(r-l+1)*val;
        tree[node].lazy+=val;
        return;
    }
    push(node,l,r);
    int mid=(l+r)>>1;
    if(ql<=mid) update(2*node,l,mid,ql,qr,val);
    if(mid<qr) update(2*node+1,mid+1,r,ql,qr,val);
    tree[node].sum=tree[2*node].sum+tree[2*node+1].sum;
}

void add(int ind)
{
    if(ind==0) return;
    int x=mp[a[ind]];
    update(1,1,n1,x+1,n1,1);
}

void rem(int ind)
{
    if(ind==0) return;
    int x=mp[a[ind]];
    update(1,1,n1,x+1,n1,-1);
}

long long query(int node,int l,int r,int ql,int qr)
{
    if(ql<=l && r<=qr) return tree[node].sum;
    push(node,l,r);
    int mid=(l+r)>>1;
    long long ret=0;
    if(ql<=mid) ret+=query(2*node,l,mid,ql,qr);
    if(mid<qr) ret+=query(2*node+1,mid+1,r,ql,qr);
    return ret;
}

long long bs(int p,int k)
{
    int l=1,r=n1;
    const double C=(double)p/1000/k;
    while(l<r)
    {
        int mid=(l+r)>>1; //
        if((S+query(1,1,n,1,mid))*C<=decode[mid]) r=mid;
        else l=mid+1;
    }
    return query(1,1,n,1,l);
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>q;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
    S+=a[i];
}
compress();
build(1,1,n1);

for(int i=0;i<q;i++)
{
    cin>>qr[i].l>>qr[i].r>>qr[i].p;
    qr[i].num=i;
}

sort(qr,qr+q,cmp);

int l=0,r=0;
for(int i=0;i<q;i++)
{
    //cout<<qr[i].l<<qr[i].r<<endl;
    while(l>qr[i].l)
    {
        add(--l);
    }
    while(r<qr[i].r)
    {
        add(++r);
    }
    while(l<qr[i].l)
    {
        rem(l++);
    }
    while(r>qr[i].r)
    {
        rem(r--);
    }

    ans[qr[i].num]=bs(qr[i].p, r-l+1);
}

for(int i=0;i<q;i++) cout<<ans[i]<<endl;

return 0;
}
/*
3 2
3 2 1
1 3 900
3 3 1000
*/
