#include <iostream>
#include <array>
#include <tuple>

// (!) Не трябва да променяте дефинициите на MemoryOperation и work. В противен случай ще получите 0 точки (compilation error).

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

// За да върнете резултат от work, трябва да върнете масив "std::array<MemoryOperation, 5>" с точно 5 елемента.
// Всеки елемент на масива е от тип "MemoryOperation", като всеки елемент може да се инициализира по следния начин:
// MemoryOperation(SET_VAL, 0, 1) -> създава "SET_VAL" операция на клетка 0 със стойност 1 (memory[0] = 1)
// MemoryOperation(ADD_VAL, 0, 1) -> създава "ADD_VAL" операция на клетка 0 със стойност 1 (memory[0] += 1)

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

// За да използвате помощни функции, те също трябва да са constexpr.
constexpr int helper() {
    return 42;
}


// Функцията е constexpr, което не ви позволява да използвате глобална памет. Можете да използвате само параметрите на функцията.
constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
   unsigned int n = memory[1];
    unsigned int m = memory[2];
    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
    };
    if (u==1)
    {
        if (memory[3]==0)
        {
            ret[0].val=1;
            ret[0].addr=3;
            ret[1].type=ADD_VAL;
            ret[1].val=1;
            ret[1].addr=3*n;
            return ret;
        }
    }

    if (u==1)
    {
        if (memory[3*n]==0)
        {
            ret[0].addr=0;
            if (memory[2*n]==n)
            {
                ret[0].val=1;
            }
            else
            {
                ret[0].val=2;
            }
            return ret;
        }
    }

    if (memory[u+2]==1)
    {
        ret[0].val=2;
        ret[0].addr=u+2;
        ret[1].type=ADD_VAL;
        ret[1].val=1;
        ret[1].addr=2*n;
        ret[2].type=ADD_VAL;
        ret[2].val=-1;
        ret[2].addr=3*n;
        return ret;
    }
    if (memory[u+2]==2) return ret;

    // Васички масиви които използваме трябва да се инициализират. Това е примерна инициализация на масива който ще върнем:

    // Може да итерирате през всички съседи на върха u по следния начин:
    for (unsigned int i = 0; i < number_neighbours; ++i) {
        unsigned int v = neighbours[i];
        if (memory[v+2]==1)
        {
            ret[0].val=1;
            ret[0].addr=u+2;
            ret[1].type=ADD_VAL;
            ret[1].val=1;
            ret[1].addr=3*n;
        }
        //ret[0] = MemoryOperation(ADD_VAL, i, v);
    }

    // Може да използвате std::array, като се инициализира по следния начин ({} след името на променливата):
    //std::array<long long, 42> arr{};

    // Може да използвате помощна функция, която е  .
    //int test = helper();

    return ret;
}
