#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 5e5;
const int INF = 1e9;

int a[MAXN + 5];
long long prf[MAXN + 5];
vector<int> mergetree[4 * MAXN + 5];
vector<long long> pref[4 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        mergetree[v] = {a[l]};
        pref[v] = {a[l]};
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);

    int ptle = 0, ptri = 0;
    while (ptle < mergetree[2 * v].size() or ptri < mergetree[2 * v + 1].size())
    {
        if (ptle == mergetree[2 * v].size()) mergetree[v].push_back(mergetree[2 * v + 1][ptri++]);
        else if (ptri == mergetree[2 * v + 1].size()) mergetree[v].push_back(mergetree[2 * v][ptle++]);
        else if (mergetree[2 * v][ptle] < mergetree[2 * v + 1][ptri]) mergetree[v].push_back(mergetree[2 * v][ptle++]);
        else mergetree[v].push_back(mergetree[2 * v + 1][ptri++]);
    }

    long long sum = 0;
    for (auto num : mergetree[v])
    {
        sum += num;
        pref[v].push_back(sum);
    }
}

int query_min(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return INF;
    if (ql <= l and r <= qr) return mergetree[v][0];

    int mid = (l + r) / 2;
    return min(query_min(2 * v, l, mid, ql, qr), query_min(2 * v + 1, mid + 1, r, ql, qr));
}

int query_max(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return 0;
    if (ql <= l and r <= qr) return mergetree[v].back();

    int mid = (l + r) / 2;
    return max(query_max(2 * v, l, mid, ql, qr), query_max(2 * v + 1, mid + 1, r, ql, qr));
}

long long query(int v, int l, int r, int ql, int qr, int val)
{
    if (r < ql or qr < l) return 0;
    if (ql <= l and r <= qr)
    {
        int pos = lower_bound(mergetree[v].begin(), mergetree[v].end(), val + 1) - mergetree[v].begin();
        pos--;
        if (pos == -1) return 0;
        return (1ll * (pos + 1) * val - pref[v][pos]);
    }

    int mid = (l + r) / 2;
    return (query(2 * v, l, mid, ql, qr, val) + query(2 * v + 1, mid + 1, r, ql, qr, val));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        prf[i] = prf[i - 1] + a[i];
    }

    build(1, 1, n);

    for (int i = 1; i <= q; ++ i)
    {
        int l, r, p;
        cin >> l >> r >> p;

        long long sum = prf[r] - prf[l - 1];
        int le = query_min(1, 1, n, l, r) - 1, ri = query_max(1, 1, n, l, r), mid;
        while (ri - le > 1)
        {
            mid = (le + ri) / 2;
            long long tmp = query(1, 1, n, l, r, mid);
            if (1ll * 1000 * (r - l + 1) * mid >= p * (sum + tmp)) ri = mid;
            else le = mid;
        }
        cout << query(1, 1, n, l, r, ri) << endl;
    }

    return 0;
}
