#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1e5;
const int INF = 1e9;

struct node
{
    int l, r;
    unsigned long long sum;
};

int szPERS = 0;
int a[MAXN + 5];
int root[MAXN + 5];
vector<node> treePERS;
long long prf[MAXN + 5];
pair<int, int> tree[2 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v].first = tree[v].second = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v].first = min(tree[2 * v].first, tree[2 * v + 1].first);
    tree[v].second = max(tree[2 * v].second, tree[2 * v + 1].second);
}

int query_min(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return INF;
    if (ql <= l and r <= qr) return tree[v].first;

    int mid = (l + r) / 2;
    return min(query_min(2 * v, l, mid, ql, qr), query_min(2 * v + 1, mid + 1, r, ql, qr));
}

int query_max(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return 0;
    if (ql <= l and r <= qr) return tree[v].second;

    int mid = (l + r) / 2;
    return max(query_max(2 * v, l, mid, ql, qr), query_max(2 * v + 1, mid + 1, r, ql, qr));
}

int pos, val;

int buildPERS(int l, int r)
{
    int idx = szPERS++;
    treePERS.push_back({-1, -1, 0});

    if (l == r)
    {
        if (l == pos) treePERS[idx].sum = 1ll * val * (MAXN + 1) + 1;
        return idx;
    }

    int mid = (l + r) / 2;
    int idx_left = buildPERS(l, mid);
    int idx_right = buildPERS(mid + 1, r);
    treePERS[idx].l = idx_left;
    treePERS[idx].r = idx_right;
    treePERS[idx].sum = treePERS[idx_left].sum + treePERS[idx_right].sum;
    return idx;
}

int prv;

int add(int l, int r)
{
    int idx = szPERS++;
    treePERS.push_back({-1, -1, 0});

    if (l == r)
    {
        treePERS[idx].sum = 1ll * val * (MAXN + 1) + 1;
        return idx;
    }

    int mid = (l + r) / 2;
    int idx_left, idx_right;
    if (pos <= mid)
    {
        idx_right = treePERS[prv].r;
        prv = treePERS[prv].l;
        idx_left = add(l, mid);
    }
    else
    {
        idx_left = treePERS[prv].l;
        prv = treePERS[prv].r;
        idx_right = add(mid + 1, r);
    }

    treePERS[idx].l = idx_left;
    treePERS[idx].r = idx_right;
    treePERS[idx].sum = treePERS[idx_left].sum + treePERS[idx_right].sum;
    return idx;
}

unsigned long long query(int idx, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return 0;
    if (ql <= l and r <= qr) return treePERS[idx].sum;

    int mid = (l + r) / 2;
    return (query(treePERS[idx].l, l, mid, ql, qr) + query(treePERS[idx].r, mid + 1, r, ql, qr));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        prf[i] = prf[i - 1] + a[i];
        v.push_back({a[i], i});
    }
    sort(v.begin(), v.end());

    build(1, 1, n);
    pos = v[0].second;
    val = v[0].first;
    root[0] = buildPERS(1, n);

    for (int i = 1; i < n; ++ i)
    {
        prv = root[i - 1];
        pos = v[i].second;
        val = v[i].first;
        root[i] = add(1, n);
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r, p;
        cin >> l >> r >> p;

        long long sum = prf[r] - prf[l - 1];
        int le = query_min(1, 1, n, l, r) - 1, ri = query_max(1, 1, n, l, r), mid;
        while (ri - le > 1)
        {
            mid = (le + ri) / 2;
            int pos = lower_bound(v.begin(), v.end(), make_pair(mid + 1, 0)) - v.begin();
            pos--;
            unsigned long long q = query(root[pos], 1, n, l, r);
            long long tmp = 1ll * q % (MAXN + 1) * mid - q / (MAXN + 1);
            if (1ll * 1000 * (r - l + 1) * mid >= p * (sum + tmp)) ri = mid;
            else le = mid;
        }
        int pos = lower_bound(v.begin(), v.end(), make_pair(ri + 1, 0)) - v.begin();
        pos--;
        unsigned long long q = query(root[pos], 1, n, l, r);
        long long ans = 1ll * q % (MAXN + 1) * ri - q / (MAXN + 1);
        cout << ans << endl;
    }

    return 0;
}
