#include <iostream>
#include <array>
#include <tuple>

// (!) Не трябва да променяте дефинициите на MemoryOperation и work. В противен случай ще получите 0 точки (compilation error).

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

// За да върнете резултат от work, трябва да върнете масив "std::array<MemoryOperation, 5>" с точно 5 елемента.
// Всеки елемент на масива е от тип "MemoryOperation", като всеки елемент може да се инициализира по следния начин:
// MemoryOperation(SET_VAL, 0, 1) -> създава "SET_VAL" операция на клетка 0 със стойност 1 (memory[0] = 1)
// MemoryOperation(ADD_VAL, 0, 1) -> създава "ADD_VAL" операция на клетка 0 със стойност 1 (memory[0] += 1)

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

// Функцията е constexpr, което не ви позволява да използвате глобална памет. Можете да използвате само параметрите на функцията.
constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    unsigned int n = memory[1];
    unsigned int m = memory[2];

    unsigned int t = memory[3]; // Времето от началото на изпълнението на програмата
    unsigned int vis0 = memory[4]; // Брой посетени върхове от началото на изпълнението на програмата

    // Всички масиви които използваме трябва да се инициализират. Това е примерна инициализация на масива който ще върнем:
    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(ADD_VAL, memory_size - 1, 0u),
        MemoryOperation(ADD_VAL, memory_size - 1, 0u),
        MemoryOperation(ADD_VAL, memory_size - 1, 0u),
        MemoryOperation(ADD_VAL, memory_size - 1, 0u),
        MemoryOperation(ADD_VAL, memory_size - 1, 0u),
    };

    int curr = 0;

    int vis = 0;
    for (int i = 5; i <= n + 4; ++ i)
    {
        if (memory[i]) vis++;
    }

    if (vis == n) ret[curr++] = MemoryOperation(SET_VAL, 0, 1u);

    if (u == 1)
    {
        if (t == 0) ret[curr++] = MemoryOperation(SET_VAL, 5, 1u);
        ret[curr++] = MemoryOperation(ADD_VAL, 3, 1u);
        ret[curr++] = MemoryOperation(SET_VAL, 4, vis);
        if (vis == vis0 and vis0 < n) ret[curr++] = MemoryOperation(SET_VAL, 0, 2u);
    }

    if (memory[u + 4] == 0) return ret;

    // Може да итерирате през всички съседи на върха u по следния начин:
    for (unsigned int i = 0; i < number_neighbours and curr < 4; ++i) {
        unsigned int v = neighbours[i];
        if (memory[v + 4] == 0 and curr + 1 < 5) ret[curr++] = MemoryOperation(SET_VAL, v + 4, 1u);
    }

    return ret;
}
