//#include "lcm.h"

#include<bits/stdc++.h>

using namespace std;

static const int N = 1e5 + 3;

static int n, n_tests;
static int input[N];

static long long number_of_queries;



static vector<int> readInput(){
    vector<int> inp(n,0);

    for(int i=0;i<n;i++)
        cin>>inp[i];

    return inp;
}

long long lcm(int i,int j)
{
    number_of_queries++;

    if(1>i || i>n || 1>j || j>n || i==j)
    {
        cout << "Your program made an invalid query." << endl;
        return -1;
    }

    return 1LL*input[i]/__gcd(input[i],input[j])*input[j];
}


//--------------------------

typedef long long ll;

vector<int> prms;
bool alo[100100];

void findprms(ll n){
  for(ll i=2;i<=n;++i){
    if(alo[i])continue;
    prms.push_back(i);
    for(ll j=i+i;j<=n;j+=i)alo[j]=1;
    }
  }

ll getlrg(ll a){
  for(ll i=prms.size()-1;i>=0;--i){
    if(a%prms[i]==0)return prms[i];
    }
  }

vector<int> guessPermutation(int n){
  findprms(n);

  ll id,lgid;
  for(ll i=1,x,lg;i<=n;++i){
    x=lcm(i,n-i+1);
    lg=getlrg(x);

    if(lg>n/2){
      lgid=lg;
      if(lcm(i,i+2 > n ? i+2-n : i+2)%lg==0)id=i;
      else id=i+1;
      break;
      }
    }

  vector<int> res(n);
  for(ll i=1;i<=n;++i){
    if(i==id)res[i-1]=lgid;
    else res[i-1]=lcm(i,id)/lgid;
    }

  return res;
  }



//--------------------------

static long long runOneTest(){
    number_of_queries = 0;

    vector<int> inp = readInput();
    for(int i=0;i<n;i++){
        input[i+1]=inp[i];
    }

    vector<int> guess = guessPermutation(n);
    if(guess != inp){
        for(ll i : guess)cout<<i<<" ";cout<<endl;
        cout << "Your program returned an incorrect answer." << endl;
        //exit(0);
    }

    cout << "Your program successfully returned the correct permutation and used " << number_of_queries << " queries." << endl;

    return number_of_queries;
}

int main(){
    cin >> n >> n_tests;

    long long max_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        max_queries = max(max_queries, runOneTest());

    cout << "Your program successfully returned the correct permutations and used " << max_queries << " queries at worst." << endl;
}
/*
10 10
2 9 3 8 5 6 7 10 1 4
2 3 5 9 8 10 1 7 6 4
3 2 7 9 8 10 1 6 4 5
7 9 1 8 4 10 5 6 2 3
7 6 10 8 3 4 5 1 2 9
7 4 10 2 1 8 5 9 3 6
3 4 10 7 1 8 6 9 2 5
3 4 5 7 8 10 1 6 2 9
3 1 4 7 8 10 5 2 6 9
8 3 4 10 2 1 9 6 5 7
*/
