#pragma once
#include <bits/stdc++.h>
#include "lcm.h"
using namespace std;

const int maxn = 1e5 + 10;
struct coef{
    int mult;
    int divider;
    double val;
    coef(){
        mult = -1;
        divider = -1;
        val - -1;
    }
    coef(int _mult, int _divider){
        mult = _mult;
        divider = _divider;
        simplify();
        val = (double) mult / (double) divider;
    }
    void simplify(){
        int gcd = __gcd(mult, divider);
        mult /= gcd;
        divider /= gcd;
    }
    bool operator<(const coef &other)const{
        return val < other.val;
    }
    bool operator>(const coef &other)const{
        return val > other.val;
    }
};

int M;
int lp[maxn];
vector<int> primes;
long long nok[maxn];
coef seq1[maxn / 2], seq2[maxn / 2]; ///gcds of nok[i] and nok[i + 1]
coef k1[maxn / 2],  k2[maxn / 2];
int p1[maxn], p2[maxn];
void init_primes(){
    static bool done = false;
    if (done == true)
        return;
    done = true;
    for (int i = 2; i < maxn; ++i){
        if (lp[i] == 0){
            lp[i] = i;
            primes.push_back(i);
        }
        for (int j = 0; j < primes.size() && primes[j] * i < maxn && primes[j] <= lp[i]; ++j)
            lp[i*primes[j]] = primes[j];
    }
}

inline void init_seqs(){
    for (int i = 1; i < M; i++)
        nok[i] = lcm(i, i + 1);
    for (int i = 1; i < M - 1; ++i){
        int gcd = __gcd(nok[i], nok[i + 1]);
        int mult = nok[i] / gcd;
        int div = nok[i + 1] / gcd;
        if (i % 2)
            seq1[i / 2 + 1] = coef(mult, div);
        else seq2[i / 2] = coef(mult, div);
    }
}

pair<int, int> find_smallest_and_biggest(coef *seq, int len){
    int smallidx = 1;
    int bigidx = 1;
    for (int i = 2; i <= len; ++i){
        if (seq[i] < seq[smallidx])
            smallidx = i;
        if (seq[i] > seq[bigidx])
            bigidx = i;
    }
    return {smallidx, bigidx};
}

coef newprop(coef a, coef b){
    long long mult = (long long) a.mult * b.divider;
    long long divider = (long long) a.divider * b.mult;
    long long gcd = __gcd(mult, divider);
    mult /= gcd;
    divider /= gcd;
    return coef(mult, divider);
}

inline void set_vals_to_ks(coef *seq, coef *k, int len){
    k[1] = coef(1, 1);
    for (int i = 2; i <= len; ++i)
        k[i] = newprop(k[i - 1], seq[i]);
}

int get_nok_all(coef *seq, int len){
    int w = seq[1].divider;
    for (int i = 2; i <= len; ++i){
        long long gcd = __gcd(w, seq[i].divider);
        long long w1 = (long long) w * (long long) seq[i].divider / gcd;
        w = w1;
    }
    return w;
}

int solve_inequality(pair<int, int> vals,coef *seq, int other, int len){
    /*coef w = seq[vals.first];
    double lbr = (double) w.divider / w.mult;
    int lb = ceil(lbr);
    w = seq[vals.second];
    double ubr = (double) w.divider / w.mult;
    int ub = floor(lbr);*/
    int nokall = get_nok_all(seq, len);
    return nokall;
}

pair<int, int> solve_inequalities(){
    int len1 = (M%2)? M / 2 + 1: M / 2;
    int len2 = M / 2;
    set_vals_to_ks(seq1, k1, len1);
    set_vals_to_ks(seq2, k2, len2);
    pair<int, int> one = find_smallest_and_biggest(k1, len1);
    pair<int, int> two = find_smallest_and_biggest(k2, len2);
    int x = get_nok_all(k1, len1);
    int y = get_nok_all(k2, len2);
    return {x, y};
}

inline void fill_p(int *p, coef *k, int start, int len){
    p[1] = start;
    for (int i = 2; i <= len; ++i){
        long long w = (long long) p[i - 1] * (long long) k[i].mult / (long long) k[i].divider;
        p[i] = w;
    }
}

vector<int> guessPermutation(int N){
    M = N;
    init_primes();
    init_seqs();
    pair<int, int> rez = solve_inequalities();
    int x = rez.first;
    int y = rez.second;
    int len1 = (M%2)? M / 2 + 1: M / 2;
    int len2 = M / 2;
    fill_p(p1, k1, x, len1);
    fill_p(p2, k2, y, len2);
    vector<int> v;
    for (int pointer = 1; pointer <= len2; ++pointer){
        v.push_back(p1[pointer]);
        v.push_back(p2[pointer]);
    }
    if (len1 > len2)
        v.push_back(p1[len1]);
    return v;
}
